package net.sf.sido.factory;

import java.io.IOException;
import java.net.URL;

import net.sf.sido.DataFactory;
import net.sf.sido.DataSchema;

public interface DataFactoryReader {

	/**
	 * Reads a schema from a file.
	 * 
	 * @param url
	 *            URL to the schema file
	 * @param factory
	 *            Factory that is used to create the schema.
	 * @return Schema
	 * @throws IOException
	 *             If the schema file cannot be read
	 */
	DataSchema read(URL url, DataFactory factory) throws IOException;

}
