package net.sf.sido.factory.json;

import java.io.IOException;

import net.sf.sido.DataObject;
import net.sf.sido.array.Array;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public class AnonymousArrayPropertyAssembler extends AbstractPropertyAssembler {

	public AnonymousArrayPropertyAssembler(String name) {
		super(name);
	}

	@Override
	public <T> void addProperty(JSONReaderContext context, JSONDataFactory factory, JSONTypeDefinition definition,
			JsonNode jProperty) throws IOException {
		// Nullable
		boolean nullable = isNullable(jProperty);
		// Constraint
		Predicate<Array<DataObject>> constraint = readConstraint(context.getFactory(), jProperty, "constraint");
		// Adds the property
		definition.getBuilder().addAnonymousArrayProperty(name, nullable, constraint);
	}
}
