package net.sf.sido.factory.json;

import java.io.IOException;

import net.sf.sido.DataObject;
import net.sf.sido.DataType;
import net.sf.sido.array.Array;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public class ArrayDOPropertyAssembler extends AbstractPropertyAssembler {

	private final String type;

	public ArrayDOPropertyAssembler(String name, String type) {
		super(name);
		this.type = type;
	}

	@Override
	public <T> void addProperty(JSONReaderContext context, JSONDataFactory factory, JSONTypeDefinition definition,
			JsonNode jProperty) throws IOException {
		// Element type
		DataType elementType = getDOType(context, factory, type);
		// Nullable
		boolean nullable = isNullable(jProperty);
		// Constraint
		Predicate<Array<DataObject>> constraint = readConstraint(context.getFactory(), jProperty, "constraint");
		// Adds the property
		definition.getBuilder().addArrayProperty(name, elementType, nullable, constraint);
	}
}
