package net.sf.sido.factory.json;

import java.io.IOException;

import org.codehaus.jackson.JsonNode;

import com.google.common.base.Predicate;

public class SimplePropertyAssembler extends AbstractPropertyAssembler {

	private final String type;

	public SimplePropertyAssembler(String name, String type) {
		super(name);
		this.type = type;
	}

	@Override
	public <T> void addProperty(JSONReaderContext context, JSONDataFactory factory, JSONTypeDefinition definition,
			JsonNode jProperty) throws IOException {
		Class<T> cls = context.getFactory().getSimpleType(type);
		// Nullable
		boolean nullable = isNullable(jProperty);
		// Constraint
		Predicate<T> constraint = readConstraint(context.getFactory(), jProperty, "constraint");
		// Builder
		definition.getBuilder().addProperty(name, nullable, cls, constraint);
	}

}
