package net.sf.sido.factory.sido.antlr;

import java.util.ArrayList;
import java.util.List;

import net.sf.sido.constraint.ConstraintDefinitions;

public class Property {

	private boolean nullable = false;
	private boolean reverse = false;
	private boolean array = false;
	private String typeName;
	private String name;
	private boolean anonymous = false;

	private Constraint constraint;
	private List<Constraint> constraints = new ArrayList<Constraint>();

	public boolean isNullable() {
		return nullable;
	}

	public void setNullable(boolean nullable) {
		this.nullable = nullable;
	}

	public boolean isReverse() {
		return reverse;
	}

	public void setReverse() {
		reverse = true;
	}

	public boolean isArray() {
		return array;
	}

	public String getTypeName() {
		return typeName;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setArray(boolean array) {
		this.array = array;
	}

	public void setTypeName(String typeName) {
		this.typeName = typeName;
	}

	public boolean isAnonymous() {
		return anonymous;
	}

	public void setAnonymous(boolean anonymous) {
		this.anonymous = anonymous;
	}

	public void pushConstraint(String id) {
		constraint = new Constraint(id);
		constraints.add(constraint);
	}

	public void pushConstraintParam(String name, String value) {
		if (constraint == null) {
			throw new IllegalStateException("No constraint is available.");
		} else {
			constraint.addParam(name, value);
		}
	}

	public void pushConstraintValue(String value) {
		if (constraint == null) {
			throw new IllegalStateException("No constraint is available.");
		} else {
			constraint.setValue(value);
		}
	}

	public ConstraintDefinitions getConstraintDefinitions() {
		return new SiDOLConstraintDefinitions(constraints);
	}

}
