package net.sf.sido.factory.sido.antlr;

import net.sf.sido.constraint.ConstraintDefinition;
import net.sf.sido.constraint.support.DOConstraintFieldNotFoundException;

import org.apache.commons.lang.StringUtils;

public class SiDOLConstraintDefinition implements ConstraintDefinition {

	private final Constraint constraint;

	public SiDOLConstraintDefinition(Constraint c) {
		constraint = c;
	}

	@Override
	public String getType() {
		return constraint.getId();
	}

	@Override
	public String getParameter(String name, boolean mainValue, boolean required, String defaultValue) {
		String value = null;
		if (mainValue) {
			value = constraint.getValue();
		}
		if (value == null) {
			value = constraint.getParam(name);
		}
		if (value == null) {
			if (required) {
				throw new DOConstraintFieldNotFoundException(name);
			} else {
				return defaultValue;
			}
		} else {
			// Trims the value
			value = StringUtils.strip(value, "\"");
			// OK
			return value;
		}
	}

}
