package net.sf.sido.factory.sido.antlr;

import java.util.List;

import net.sf.sido.constraint.ConstraintDefinition;
import net.sf.sido.constraint.ConstraintDefinitions;

import com.google.common.base.Function;
import com.google.common.collect.Lists;

public class SiDOLConstraintDefinitions implements ConstraintDefinitions {

	private final List<Constraint> constraints;

	public SiDOLConstraintDefinitions(List<Constraint> constraints) {
		this.constraints = constraints;
	}

	@Override
	public List<ConstraintDefinition> getConstraintDefinitions() {
		return Lists.transform(constraints, new Function<Constraint, ConstraintDefinition>() {

			@Override
			public ConstraintDefinition apply(Constraint c) {
				return new SiDOLConstraintDefinition(c);
			}
		});
	}

}
