package net.sf.sido.io;

import net.sf.sido.DataFactory;

import javax.annotation.PostConstruct;

/**
 * This class sets the {@link SiDODeserializerContext} using a {@link net.sf.sido.DataFactory}.
 */
public class SiDODeserializerContextSetter {

    private final DataFactory dataFactory;

    /**
     * Sets the {@link DataFactory} to be used
     * @param dataFactory Data factory to be set
     */
    public SiDODeserializerContextSetter(DataFactory dataFactory) {
        this.dataFactory = dataFactory;
    }

    /**
     * This method initializes the deserialization context.
     */
    @PostConstruct
    public void init() {
        // Sets the deserialization context
        SiDODeserializerContext.setGlobalDataFactory(dataFactory);
    }
}
