package net.sf.sido.support;

import java.util.Map;

import net.sf.sido.DataObject;
import net.sf.sido.ParentLink;
import net.sf.sido.Property;
import net.sf.sido.PropertyController;
import net.sf.sido.PropertyMetaInfos;

public class AnonymousPropertyController implements PropertyController<DataObject> {

	private final boolean reverse;

	public AnonymousPropertyController(boolean reverse) {
		this.reverse = reverse;
	}

	@Override
	public DataObject getDefaultValue(boolean deep) {
		return null;
	}

	@Override
	public void control(Property<DataObject> property, DataObject o, DataObject value) {
		// Parent relation-ship
		if (reverse) {
			value.setParentLink(new ParentLink(o, property.getName()));
		}
	}

	@Override
	public void fillMetaInfo(Map<String, Object> mi) {
		mi.put(PropertyMetaInfos.REVERSE, reverse);
		mi.put(PropertyMetaInfos.DO, true);
	}

}
